﻿* Encoding: UTF-8.
*Neighbourhood chains
*SPSS macros by Kirill Orlov
*kior@comtv.ru, ttnphns@gmail.com
*https://www.spsstools.net/en/KO-spssmacros
*All rights reserved.

*/*!KO_NEITAB*/***********************************************.
define !KO_neitab(cols= !charend('/') /prox= !charend('/') /symm= !charend('/') /diag= !charend('/')
              /neighb= !charend('/') /tied= !charend('/') /tiecrit= !charend('/') /source= !charend('/'))
!if (!prox<>'DISSIM' !and !prox<>'SIMIL') !then
-echo '>ERROR. Incorrectly specified PROX.'.
!else
 !if (!prox='DISSIM') !then !let !proxlab= 'Distance' !else !let !proxlab= 'Similarity' !ifend
-set mxloops 100000.
-matrix.
-comp ok= 1.
 !if (!source<>!null) !then
- get source /var= source.
- comp dsource= design(source).
- comp nmat= ncol(dsource).
- comp size= csum(dsource).
- loop i= 2 to nmat.
- end loop if size(i)<>size(i-1).
- do if i<nmat+1.
-  comp ok= 0.
-  print /title '>ERROR. According to variable SOURCE, matrices have unequal number of rows.'.
- else.
-  comp blk= make(size(1),1,1).
-  loop i= 2 to nmat.
-   comp blk= block(blk,make(size(1),1,1)).
-  end loop.
-  do if any(blk<>dsource).
-   comp ok= 0.
-   print /title ">ERROR. Same values in variable SOURCE don't go in succession.".
-  end if.
- end if.
- release dsource,blk.
 !ifend
-get dd /vari= !cols /names= cn.
-comp k= ncol(dd).
-do if k<3.
- comp ok= 0.
- print /title '>ERROR. Number of columns COLS less than 3.'.
-end if.
-get rn /var= varname_.
 !if (!source=!null) !then
- comp size= nrow(dd).
 !else
- comp size= size(1).
 !ifend
-comp ind= 0.
-loop i= 1 to k.
- loop j= 1 to size.
- end loop if cn(i)=rn(j).
- do if j>size.
-  comp ok= 0.
-  print cn(i) /title ">ERROR. This name wasn't found in VARNAME_ for 1st matrix:" /format= a8.
-  break.
- else.
-  comp ind= {ind,j}.
- end if.
-end loop.
 comp ind= ind(2:(k+1)).
 !if (!prox='SIMIL') !then
- comp dd= -dd.
 !ifend
-do if ok.
  !if (!source<>!null) !then
   !let !mi= 'make(k,1,mi),' !let !mt= 'source'
-  comp dd= {dd;make(1,k,0)}.
-  loop matn= 1 to nmat.
-   comp d= dd(ind,:).
-   comp dd= dd((size+1):nrow(dd),:).
-   comp mi= source(size*matn).
  !else
-   comp d= dd(ind,:).
  !ifend
   !if (!symm='LOWER') !then
-   loop i= 1 to k.
-    comp d(i,:)= t(d(:,i)).
-   end loop.
   !ifend
   !if (!symm='UPPER') !then
-   loop i= 1 to k.
-    comp d(:,i)= t(d(i,:)).
-   end loop.
   !ifend
   !if (!symm='AVERAGE') !then
-   comp d= (d+t(d))/2.
   !ifend
   !if (!diag<>'USE') !then !let !mo= '-1'
-   call setdiag(d,mmax(d)+1).
   !ifend
   !if (!neighb='MEDIAN') !then !let !nblab= 'Median neighbour'
-   comp prox= make(k,1,0).
-   loop i= 1 to k.
-    comp sdr= d(i,:).
-    comp sdr(grade(sdr))= sdr.
-    comp prox(i)= sdr(rnd((k !mo)/2)).
-   end loop.
   !else !let !nblab= 'Nearest neighbour'
-   comp prox= rmin(d).
   !ifend
    !if (!tiecrit=!null) !then !let !tcr= 0 !else !let !tcr= !tiecrit !ifend
    !if (!tied='FIRST' !or !tied=!null) !then !let !nc= 1 !let !brk= 'break'
    !else !let !nc= 'k' !let !compc1= 'comp c= 0' !let !compc2= 'comp c= c+1' !let !c= ',c'
    !ifend
-   comp nnn= make(k,!nc,0).
-   loop i= 1 to k.
-    !compc1.
-    loop j= 1 to k.
-     do if abs(d(i,j)-prox(i))<=!tcr.
-      !compc2.
-      comp nnn(i !c)= j.
-      !brk.
-     end if.
-    end loop.
-   end loop.
    !if (!tied='RANDOM' !or !tied='DILATAT' !or !tied='CONTRACT') !then 
-    comp nnnn= rsum(nnn>0).
     !if (!tied<>'RANDOM') !then
-     comp wnnn= make(k,k,0).
-     loop i= 1 to k.
-      do if nnnn(i)>1.
-       loop j= 1 to nnnn(i).
-        comp ij= nnn(i,j).
-        comp wnnn(i,j)= any(nnn(ij,:)=i)/nnnn(ij).
-        loop h= 1 to nnnn(ij).
-         do if nnn(ij,h)<>i.
-          comp wnnn(i,j)= wnnn(i,j)+any(nnn(nnn(ij,h),:)=ij)/nnnn(nnn(ij,h))*1/nnnn(ij).
-         end if.
-        end loop.
         !if (!tied='DILATAT') !then
-         comp wnnn(i,j)= wnnn(i,j)+any(nnn(ij,:)=i)/nnnn(ij).
-         loop h= 1 to nnnn(ij).
-          comp nnn(ij,h)= nnn(ij,h).
-          do if nnn(ij,h)<>i.
-           comp wnnn(i,j)= wnnn(i,j)+any(nnn(nnn(ij,h),:)=i)/nnnn(nnn(ij,h))*1/nnnn(ij).
-          end if.
-         end loop.
         !else
-         comp wnnn(i,j)= 1-wnnn(i,j).
-         do if any(nnn(ij,:)=i)/nnnn(ij)<1.
-          comp num= 0.
-          comp denom= 0.001.
-          loop r= 1 to k.
-           do if all(r<>{i,ij}).
-            comp coef= 1-any(r=nnn(ij,:))/nnnn(ij).
-            comp num= num+any(nnn(r,:)=i)*coef.
-            comp denom= denom+nnnn(r)*coef.
-           end if.
-          end loop.
-          comp wnnn(i,j)= wnnn(i,j)+(1-any(nnn(ij,:)=i)/nnnn(ij))*num/denom.
-         end if.
         !ifend
-       end loop.
-      end if.
-     end loop.
-     comp maxwnnn= rmax(wnnn).
     !ifend
-    loop i= 1 to k.
-     do if nnnn(i)>1.
       !if (!tied='RANDOM') !then
-       comp nnn(i,1)= nnn(i,rnd(uniform(1,1)*(nnnn(i)-1)+1)).
       !else
-       loop j= 1 to nnnn(i).
-       end loop if wnnn(i,j)= maxwnnn(i).
-       comp nnn(i,1)= nnn(i,j).
       !ifend
-     end if.
-    end loop.
-    comp nnn= nnn(:,1).
    !ifend
    !if (!tcr<>0) !then
-    loop i= 1 to k.
-     comp prox(i)= d(i,nnn(i)).
-    end loop.
    !ifend
-   comp nhn= make(k,1,0).
-   comp ptt= make(k,1,0).
-   comp nh= 1.
-   comp i= 1.
-   loop if i<=k.
-    do if not nhn(i).
-     comp nhn(i)= nh.
-     comp i= nnn(i).
-    else.
-     do if nhn(i)<>nh.
-      comp nhn= nhn&*(nhn<>nh)+(nhn=nh)*nhn(i).
-     else.
-      comp nh= nh+1.
-      comp j= i.
-      loop.
-       comp ptt(j)= 1.
-       comp j= nnn(j).
-      end loop if j=i.
-     end if.
-     loop i= 1 to k.
-     end loop if not nhn(i).
-    end if.
-   end loop.
-   loop i= 1 to k.
-    do if all(nnn<>i).
-     comp ptt(i)= 3.
-    end if.
-   end loop.
-   comp ptt= ptt+(not ptt)*2.
    !if (!prox='SIMIL') !then
-    comp prox= -prox.
    !ifend
-   save {!mi t(1:k),t(cn),nnn,t(cn(nnn)),prox,nhn,ptt} /outfile= * /vari= !mt pt ptlbl nb nblbl prox nh ptt /string= !if (!source='STR') !then source !ifend ptlbl nblbl.
  !if (!source<>!null) !then
-  end loop.
  !ifend
-end if.
-end matrix.
-format pt nb nh ptt (f8).
-var lev pt nb nh ptt (nom) /prox (sca).
-var wid pt nb nh ptt (5).
-var lab pt 'Point (number)' ptlbl 'Point (label)' nb !quote(!conc(!nblab,' (number)')) nblbl !quote(!conc(!nblab,' (label)')) prox !quote(!proxlab) nh 'Neighbourhood' ptt 'Point type'.
-val lab ptt 1 'Core' 2 'Intermediate' 3 'Peripheral'.
!ifend
!enddefine.

*/*!KO_NEIPLOT*/***********************************************.
define !KO_neiplot(outfile= !charend('/') /print= !charend('/') /width= !charend('/') /field= !charend('/') /prox= !charend('/') /source= !charend('/') /cos= !charend('/')
               /scale= !charend('/') !default(25))
!if (!outfile=!null) !then
-echo '>ERROR. Not specified OUTFILE'.
!else
 !if (!width=!null) !then !let !w= 8 !else !let !w= !width !ifend
 !if (!field=!null) !then !let !fld= 255 !else !let !fld= !field !ifend
-set mxloops 100000.
-matrix.
-get pt /var= pt.
-comp k= cmax(pt).
-do if mod(nrow(pt),k).
- print /title ">ERROR. Either values in variable PT aren't 1,2,...,number_rows_table,".
- print /title '        or not all tables have equal number of rows.' /space= 0.
-else if any(pt(1:k)<>t({1:k})).
- print /title ">ERROR. Either values in variable PT aren't 1,2,...,number_rows_table,".
- print /title '        or go not ascendingly.' /space= 0.
-else.
- comp ntab= nrow(pt)/k.
- release pt.
- get nbvar /var= nb.
- get nhvar /var= nh.
- get pttvar /var= ptt.
  !if (!print='LABELS') !then !let !f= 'a'
-  get ptlab /var= ptlbl.
-  comp ptlab= ptlab(1:k).
  !else !let !f= 'f'
  !ifend
  !if (!source=!null) !then
-  comp ntab= 1.
  !else
-  get tnvar /var= source.
  !ifend
  !if (!prox<>!null) !then
-  get dd /var= prox.
   !if (!prox='SIMIL') !then
-   comp dd= -dd.
   !ifend
-  comp dd= dd&*(pttvar<>1)+(cmax(dd)-cmin(dd))/2*(pttvar=1).
-  comp dd= rnd((!scale-1)/(cmax(dd)-cmin(dd))*(dd-cmax(dd))+!scale).
  !ifend
- comp tnlist= 0.
- comp mm= make(k**2,1,0).
- loop tabn= 1 to ntab.
-  comp nnn= nbvar(((tabn-1)*k+1):(tabn*k)).
-  comp nhn= nhvar(((tabn-1)*k+1):(tabn*k)).
-  comp ptt= pttvar(((tabn-1)*k+1):(tabn*k)).
   !if (!source<>!null) !then
-   comp tn= tnvar((tabn-1)*k+1).
-   comp tnlist= {tnlist,tn}.
-   write {'******* ','SOURCE: ','********','********','********'} /field= 1 to !fld /format= a8 /outfile= !outfile.
-   write '        ' /field= 1 to !fld /format= a8 /hold.
-   write tn /field= 1 to !fld /format= !if (!source='STR') !then a8 !else f !ifend.
-   write ' ' /field= 1 to !fld /format= a1.
   !ifend
   !if (!prox<>!null) !then
-   comp d= dd(((tabn-1)*k+1):(tabn*k)).
   !ifend
-  loop nh= 1 to cmax(nhn).
-   comp ntails= csum(nhn=nh and ptt=3).
-   comp tails= make(ntails+1,csum(nhn=nh and ptt=2)+2,0).
-   do if ntails.
-    comp r= 0.
-    loop i= 1 to k.
-     do if nhn(i)=nh and ptt(i)=3.
-      comp r= r+1.
-      comp j= i.
-      loop c= ncol(tails) to 1 by -1.
-       comp tails(r,c)= j.
-       comp j= nnn(j).
-      end loop if ptt(j)=1.
-      comp tails(r,c-1)= j.
-     end if.
-    end loop.
-    loop r= 1 to nrow(tails)-1.
-     comp npos= rsum(tails(r,:)>0).
-     comp tails(r,1:npos)= tails(r,(ncol(tails)-npos+1):ncol(tails)).
-     do if npos<ncol(tails).
-      comp tails(r,(npos+1):ncol(tails))= tails(r,(npos+1):ncol(tails))*0.
-     end if.
-    end loop.
-    comp tails(grade(tails(:,1)),:)= tails.
-    loop i= 2 to ncol(tails).
-     comp lst= 0.
-     loop.
-      comp fst= lst+1.
-      loop lst= fst to nrow(tails)-1.
-      end loop if tails(lst+1,i-1)<>tails(lst,i-1).
-      comp tails(grade(tails(fst:lst,i))+fst-1,:)= tails(fst:lst,:).
-     end loop if lst=nrow(tails).
-    end loop.
-   end if.
-   comp ncore= csum(nhn=nh and ptt=1).
-   comp nei= make(ncore+nrow(tails),ncol(tails),0).
-   comp r2= 0.
-   comp coren= 0.
-   loop i= 1 to k.
-   end loop if nhn(i)=nh and ptt(i)=1.
-   loop.
-    comp coren= coren+1.
-    do if any(tails(:,1)=i).
-     loop r1= 1 to nrow(tails).
-      do if tails(r1,1)=i.
-       comp r2= r2+1.
-       comp nei(r2,:)= tails(r1,:).
-      end if.
-     end loop.
-    else.
-     comp r2= r2+1.
-     comp nei(r2,1)= i.
-    end if.
-    comp i= nnn(i).
-   end loop if coren=ncore.
-   comp nei= nei(1:(r2+1),:).
-   comp nei= {nei,make(r2+1,1,0)}.
    !if (!prox=!null) !then !let !blnk= '{" "," "," "," "}' !let !arrw= '{" ","<","-"," "}'
    !else !let !blnk= '{" "," ",make(1,d(nei(r,c+1))," ")," "}' !let !arrw= '{" ","<",make(1,d(nei(r,c+1)),"-")," "}'
    !ifend
-   loop r= 1 to nrow(nei)-1.
-    loop c= 1 to ncol(nei)-1.
-     do if nei(r,c)=nei(r+1,c).
-      write ' ' /field= 1 to !fld /format= !conc('a',!w) /hold
                 /outfile= !outfile.
-     else.
-      write !if (!print='LABELS') !then ptlab !ifend (nei(r,c)) /field= 1 to !fld /format= !conc(!f,!w) /hold
                 /outfile= !outfile.
-     end if.
-     do if not nei(r,c+1).
-      write ' ' /field= 1 to !fld /format= a1.
-      break.
-     else if nei(r,c)=nei(r+1,c) and nei(r,c+1)=nei(r+1,c+1).
-      write !blnk /field= 1 to !fld /format= a1 /hold.
-     else.
-      write !arrw /field= 1 to !fld /format= a1 /hold.
-     end if.
-    end loop.
-   end loop.
-   write ' ' /field= 1 to !fld /format= a1.
-   do if cmax(nhn)>1 and nh<cmax(nhn).
-    write {'*';' '} /field= 1 to !fld /format= a1.
-   end if.
-  end loop.
   !if (!source='STR' !and (!cos='LINK' !or !cos='CHAIN')) !then
-   comp m= make(k,k,0).
-   loop i= 1 to k.
     !if (!cos='LINK') !then
-     comp j= nnn(i).
-     comp m(i,j)= 1.
-     do if j=i or nnn(j)=i.
-      comp m(j,i)= 1.
-     else.
-      comp m(j,i)= -1.
-     end if.
     !else
-     comp j= i.
-     loop if not m(i,nnn(j)).
-      comp j= nnn(j).
-      comp m(i,j)= 1.
-      do if ptt(i)=1 and ptt(j)=1.
-       comp m(j,i)= 1.
-      else.
-       comp m(j,i)= -1.
-      end if.
-     end loop if nnn(j)=i.
     !ifend
-   end loop.
-   comp mm= {mm,reshape(m,k**2,1)}.
   !ifend
- end loop.
  !if (!source='STR' !and (!cos='LINK' !or !cos='CHAIN')) !then
-  comp mm= mm(:,2:ncol(mm)).
-  comp mm= sscp(mm).
-  comp ss= kroneker(diag(mm),make(1,ntab,1)).
-  comp mm= mm/sqrt(ss&*t(ss)).
-  comp tnlist= tnlist(2:ncol(tnlist)).
-  comp names= {'rowtype_','varname_',tnlist}.
-  save {make(ntab,1,'PROX'),t(tnlist),mm} /outfile= * /names= names /string= rowtype_ varname_.
  !ifend
-end if.
!ifend
end matrix.
!if (!source='STR' !and (!cos='LINK' !or !cos='CHAIN')) !then
-val lab rowtype_ 'PROX' 'SIMILARITY COSINE'.
!ifend
!enddefine.
